Package org.codehaus.groovy.transform

# Class SealedASTTransformation

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.SealedASTTransformation

All Implemented Interfaces:
  `ASTTransformation`, `ErrorCollecting`

public class SealedASTTransformation extends AbstractASTTransformation
Handles generation of code for the @Sealed annotation.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `SEALED_ALWAYS_ANNOTATE`
  Deprecated.

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SealedASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static List<ClassNode>`
  `getDeclaredPermittedSubclasses(ClassNode cNode)`
  Returns the explicitly-declared permitted-subclass list for `cNode`, either from the populated `permittedSubclasses` field (after the transform has run) or from the `@Sealed` annotation's `permittedSubclasses` member.
  `static List<ClassNode>`
  `getEffectivePermittedSubclasses(ClassNode cNode)`
  Returns the effective permitted-subclass list for `cNode`: the explicitly-declared list when present, otherwise the inferred list obtained by scanning the enclosing compilation unit for direct subtypes (mirroring `SealedCompletionASTTransformation`).
  `static boolean`
  `sealedNative(AnnotatedNode node)`
  Reports true if native sealed class information should be written into the bytecode.
  `static boolean`
  `sealedSkipAnnotation(AnnotatedNode node)`
  Reports true if the `Sealed` annotation should not be included in the bytecode for a sealed or emulated-sealed class.
  `static boolean`
  `sealedSkipAnnotationFromSource(ClassNode cNode)`
  Reports whether the source for `cNode` uses `@SealedOptions(alwaysAnnotate=false)` — independent of compile-phase ordering, so callers earlier than `SEMANTIC_ANALYSIS` can use it.
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.
  `static boolean`
  `wouldBeNativeSealed(ClassNode cNode, String targetBytecode)`
  Reports whether `cNode` would receive native sealed bytecode for the given `targetBytecode` level.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getAnnotationName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### SEALED_ALWAYS_ANNOTATE

    @Deprecated public static final String SEALED_ALWAYS_ANNOTATE
    Deprecated.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### SealedASTTransformation

    public SealedASTTransformation()

- ## Method Details

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

  - ### sealedNative

    public static boolean sealedNative(AnnotatedNode node)
    Reports true if native sealed class information should be written into the bytecode. Will only ever return true after the SealedASTTransformation visit method has completed.
    Returns:
      true for a native sealed class

  - ### sealedSkipAnnotation

    public static boolean sealedSkipAnnotation(AnnotatedNode node)
    Reports true if the `Sealed` annotation should not be included in the bytecode for a sealed or emulated-sealed class. Will only ever return true after the `SealedASTTransformation` transform has been invoked.
    Returns:
      true if a `Sealed` annotation is not required for this node

  - ### wouldBeNativeSealed

    public static boolean wouldBeNativeSealed(ClassNode cNode, String targetBytecode)
    Reports whether `cNode` would receive native sealed bytecode for the given `targetBytecode` level. Independent of compile-phase ordering, so callers earlier than `SEMANTIC_ANALYSIS` (e.g. the joint-compile stub generator) can use it.
    Parameters:
      `cNode` - the class being checked
      `targetBytecode` - the target bytecode level (see `CompilerConfiguration.getTargetBytecode()`)

  - ### getDeclaredPermittedSubclasses

    public static List<ClassNode> getDeclaredPermittedSubclasses(ClassNode cNode)
    Returns the explicitly-declared permitted-subclass list for `cNode`, either from the populated `permittedSubclasses` field (after the transform has run) or from the `@Sealed` annotation's `permittedSubclasses` member. An empty list means no explicit list is declared in source — inference happens later via `SealedCompletionASTTransformation`. Independent of compile-phase ordering, so callers earlier than `SEMANTIC_ANALYSIS` can use it.

  - ### getEffectivePermittedSubclasses

    public static List<ClassNode> getEffectivePermittedSubclasses(ClassNode cNode)
    Returns the effective permitted-subclass list for `cNode`: the explicitly-declared list when present, otherwise the inferred list obtained by scanning the enclosing compilation unit for direct subtypes (mirroring `SealedCompletionASTTransformation`). Phase independent, so callers earlier than `CANONICALIZATION` can use it.

  - ### sealedSkipAnnotationFromSource

    public static boolean sealedSkipAnnotationFromSource(ClassNode cNode)
    Reports whether the source for `cNode` uses `@SealedOptions(alwaysAnnotate=false)` — independent of compile-phase ordering, so callers earlier than `SEMANTIC_ANALYSIS` can use it.